"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AcmgEvidence(ProtocolElement):
    """
    AcmgEvidence. This should be buit for each one of the evidences assing
    to a variants following the ACMG guidelines.     An AcmgEvidence,
    should map with one of the criteria defined, i.e, PVS1, BA1,
    PM1...
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "category",
        "modifier",
        "type",
        "weight",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_7 import reports as reports_6_1_1

        return {
            "activationStrength": reports_6_1_1.ActivationStrength,
            "category": reports_6_1_1.AcmgEvidenceCategory,
            "type": reports_6_1_1.AcmgEvidenceType,
            "weight": reports_6_1_1.AcmgEvidenceWeight,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_7 import reports as reports_6_1_1

        return {
            "org.gel.models.report.avro.ActivationStrength": reports_6_1_1.ActivationStrength,
            "org.gel.models.report.avro.AcmgEvidenceCategory": reports_6_1_1.AcmgEvidenceCategory,
            "org.gel.models.report.avro.AcmgEvidenceType": reports_6_1_1.AcmgEvidenceType,
            "org.gel.models.report.avro.AcmgEvidenceWeight": reports_6_1_1.AcmgEvidenceWeight,
            "org.gel.models.report.avro.AcmgEvidence": reports_6_1_1.AcmgEvidence,
        }

    __slots__ = [
        "category",
        "modifier",
        "type",
        "weight",
        "activationStrength",
        "description",
    ]

    def __init__(
        self,
        category,
        modifier,
        type,
        weight,
        activationStrength=None,
        description=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_1_1.AcmgEvidence model.

        :param category:
            Evidence category as defined in ACMG guidelines
        :type category: AcmgEvidenceCategory
        :param modifier:
            modifier of the strength, together define each creteria, i.e the 2 in
            PM2
        :type modifier: int
        :param type:
            Evidence type: bening or pathogenic
        :type type: AcmgEvidenceType
        :param weight:
            Weight categories as described in ACMG guideline
        :type weight: AcmgEvidenceWeight
        :param activationStrength:
            Activation Strength
        :type activationStrength: None | ActivationStrength
        :param description:
            Description of the evidence
        :type description: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.1.1"
